Teach git-stash to "apply --index"
[git/dkf.git] / git-stash.sh
blob5c63ca5bce1180a6a6182a73ec5a75b7580580ab
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
6 . git-sh-setup
7 require_work_tree
9 TMP="$GIT_DIR/.git-stash.$$"
10 trap 'rm -f "$TMP-*"' 0
12 ref_stash=refs/stash
14 no_changes () {
15 git diff-index --quiet --cached HEAD &&
16 git diff-files --quiet
19 clear_stash () {
20 logfile="$GIT_DIR/logs/$ref_stash" &&
21 mkdir -p "$(dirname "$logfile")" &&
22 : >"$logfile"
25 save_stash () {
26 stash_msg="$1"
28 if no_changes
29 then
30 echo >&2 'No local changes to save'
31 exit 0
33 test -f "$GIT_DIR/logs/$ref_stash" ||
34 clear_stash || die "Cannot initialize stash"
36 # state of the base commit
37 if b_commit=$(git rev-parse --verify HEAD)
38 then
39 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
40 else
41 die "You do not have the initial commit yet"
44 if branch=$(git symbolic-ref -q HEAD)
45 then
46 branch=${branch#refs/heads/}
47 else
48 branch='(no branch)'
50 msg=$(printf '%s: %s' "$branch" "$head")
52 # state of the index
53 i_tree=$(git write-tree) &&
54 i_commit=$(printf 'index on %s' "$msg" |
55 git commit-tree $i_tree -p $b_commit) ||
56 die "Cannot save the current index state"
58 # state of the working tree
59 w_tree=$( (
60 GIT_INDEX_FILE="$TMP-index" &&
61 export GIT_INDEX_FILE &&
63 rm -f "$TMP-index" &&
64 git read-tree $i_tree &&
65 git add -u &&
66 git write-tree &&
67 rm -f "$TMP-index"
68 ) ) ||
69 die "Cannot save the current worktree state"
71 # create the stash
72 if test -z "$stash_msg"
73 then
74 stash_msg=$(printf 'WIP on %s' "$msg")
75 else
76 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
78 w_commit=$(printf '%s\n' "$stash_msg" |
79 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
80 die "Cannot record working tree state"
82 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
83 die "Cannot save the current status"
84 printf >&2 'Saved "%s"\n' "$stash_msg"
87 have_stash () {
88 git rev-parse --verify $ref_stash >/dev/null 2>&1
91 list_stash () {
92 have_stash || return 0
93 git log --pretty=oneline -g "$@" $ref_stash |
94 sed -n -e 's/^[.0-9a-f]* refs\///p'
97 show_stash () {
98 flags=$(git rev-parse --no-revs --flags "$@")
99 if test -z "$flags"
100 then
101 flags=--stat
103 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
105 w_commit=$(git rev-parse --verify "$s") &&
106 b_commit=$(git rev-parse --verify "$s^") &&
107 git diff $flags $b_commit $w_commit
110 apply_stash () {
111 git diff-files --quiet ||
112 die 'Cannot restore on top of a dirty state'
114 unstash_index=
115 case "$1" in
116 --index)
117 unstash_index=t
118 shift
119 esac
121 # current index state
122 c_tree=$(git write-tree) ||
123 die 'Cannot apply a stash in the middle of a merge'
125 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
126 w_tree=$(git rev-parse --verify "$s:") &&
127 b_tree=$(git rev-parse --verify "$s^:") ||
128 die "$*: no valid stashed state found"
130 test -z "$unstash_index" || {
131 git diff --binary $s^2^..$s^2 | git apply --cached
132 test $? -ne 0 &&
133 die 'Conflicts in index. Try without --index.'
134 unstashed_index_tree=$(git-write-tree) ||
135 die 'Could not save index tree'
136 git reset
139 eval "
140 GITHEAD_$w_tree='Stashed changes' &&
141 GITHEAD_$c_tree='Updated upstream' &&
142 GITHEAD_$b_tree='Version stash was based on' &&
143 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
146 if git-merge-recursive $b_tree -- $c_tree $w_tree
147 then
148 # No conflict
149 a="$TMP-added" &&
150 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
151 git read-tree --reset $c_tree &&
152 git update-index --add --stdin <"$a" ||
153 die "Cannot unstage modified files"
154 git-status
155 rm -f "$a"
156 test -z "$unstash_index" || git read-tree $unstashed_index_tree
157 else
158 # Merge conflict; keep the exit status from merge-recursive
159 status=$?
160 test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
161 exit $status
165 # Main command set
166 case "$1" in
167 list)
168 shift
169 if test $# = 0
170 then
171 set x -n 10
172 shift
174 list_stash "$@"
176 show)
177 shift
178 show_stash "$@"
180 apply)
181 shift
182 apply_stash "$@"
184 clear)
185 clear_stash
187 help | usage)
188 usage
191 if test $# -gt 0 && test "$1" = save
192 then
193 shift
195 save_stash "$*" && git-reset --hard
197 esac